#include "ConfigureManager.h"
#include "ExceptionManager.h"
#include <string.h>

using namespace CloudResourceManager;
using namespace std;

char ConfigureManager::appSettingPath[1024];
StringMap ConfigureManager::hashTable;

/*
string AppConfigureManager::userScriptPath = ConfigureManager::appSettings("userScriptPath");//("userScriptPath");
string AppConfigureManager::userSubmitPath = ConfigureManager::appSettings("userSubmitPath");// "H:\\s3operation\\";
string AppConfigureManager::userTemplatePath = ConfigureManager::appSettings("userTemplatePath");// "F:\\My Dropbox\\CloudResourceManager\\CloudResourceManager\\SubFiles\\";
string AppConfigureManager::userBatchPath = ConfigureManager::appSettings("userBatchPath");
string AppConfigureManager::userDataPath = ConfigureManager::appSettings("userDataPath");
*/

string ConfigureManager::appSettings(const string& key)
{
    if (appSettingPath[0] == '\0')
    {
        readlink("/proc/self/exe", appSettingPath, sizeof(appSettingPath));
        strcpy(appSettingPath + strlen(appSettingPath), ".xml");
        XmlManager::GetHashTableHelper(appSettingPath, hashTable);
    }
    StringMap::const_iterator it = hashTable.find(key);
    int size = hashTable.size();
    if (it != hashTable.end())
    {
        return it->second;
    }
    else
    {
        string errMsg = "cannot find app setting of ";
        errMsg += key;
        //debugging..
        FILE_LOG(logERROR)<<errMsg;
        for (it = hashTable.begin(); it != hashTable.end(); it ++)
        {
            FILE_LOG(logDEBUG)<<"key="<<it->first<<";value="<<it->second;
        }
        //throw XmlException(errMsg);
    }
}

ConfigureManager::~ConfigureManager()
{
    FILE_LOG(logDEBUG)<<"~ConfigureManager";
}
